abstract class ChatAction {
  const ChatAction();

  Map<String, dynamic> toJson();

  factory ChatAction.fromJson(Map<String, dynamic> json) {
    if (json != null) {
      if (json['type'] == 'sendMessage') {
        return SendMessageAction.fromJson(json);
      }
    }
    return null;
  }
}

class SendMessageAction extends ChatAction {
  final String content;
  const SendMessageAction(this.content);

  factory SendMessageAction.fromJson(Map<String, dynamic> json) =>
      SendMessageAction(json['content']);

  @override
  Map<String, dynamic> toJson() => {
        'type': 'sendMessage',
        'content': content,
      };
}
