import 'package:meta/meta.dart';

abstract class ChatUpdate {
  const ChatUpdate();

  Map<String, dynamic> toJson();

  factory ChatUpdate.fromJson(Map<String, dynamic> json) {
    if (json != null) {
      if (json['type'] == 'receivedMessage') {
        return ReceivedMessageUpdate.fromJson(json);
      }
    }
    return null;
  }
}

class ReceivedMessageUpdate extends ChatUpdate {
  final String email;
  final String content;
  const ReceivedMessageUpdate({
    @required this.content,
    @required this.email,
  });

  factory ReceivedMessageUpdate.fromJson(Map<String, dynamic> json) =>
      ReceivedMessageUpdate(
        email: json['email'],
        content: json['content'],
      );

  @override
  Map<String, dynamic> toJson() => {
        'type': 'receivedMessage',
        'email': email,
        'content': content,
      };
}
