import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:meta/meta.dart';

part 'model.freezed.dart';
part 'model.g.dart';

@freezed
abstract class KeenRequest with _$KeenRequest {
  const factory KeenRequest({
    @required String requestId,
    @required Map<String, dynamic> value,
  }) = _KeenRequest;

  factory KeenRequest.fromJson(Map<String, dynamic> json) =>
      _$KeenRequestFromJson(json);
}

@freezed
abstract class KeenResponse with _$KeenResponse {
  const factory KeenResponse.update({
    String requestId,
    @required Map<String, dynamic> value,
  }) = KeenUpdateResponse;

  const factory KeenResponse.error({
    @required String requestId,
    @required KeenError error,
  }) = KeenErrorResponse;

  const factory KeenResponse.empty({
    @required String requestId,
  }) = KeenEmptyResponse;

  factory KeenResponse.fromJson(Map<String, dynamic> json) =>
      _$KeenResponseFromJson(json);
}

@freezed
abstract class KeenError with _$KeenError {
  const factory KeenError({
    @required int code,
    @required String message,
  }) = _KeenError;

  factory KeenError.fromJson(Map<String, dynamic> json) =>
      _$KeenErrorFromJson(json);
}

abstract class KeenErrorCodes {
  static const internalServerError = 500;
}
