import 'package:keen/client.dart';
import 'package:meta/meta.dart';

class KeenClient<Action, Update> {
  final KeenAuthClient auth;
  final KeenSerializer<Action> _actionSerializer;
  final KeenDeserializer<Update> _updateDeserializer;

  KeenClient({
    @required dynamic url,
    @required KeenSerializer<Action> actionSerializer,
    @required KeenDeserializer<Update> updateDeserializer,
  })  : auth = KeenAuthClient(url: url),
        _actionSerializer = actionSerializer,
        _updateDeserializer = updateDeserializer;

  /// Open a socket a create an authenticated api client.
  KeenApiClient<Action, Update> connect(Token token) {
    if (token.isExpired) throw Exception('Expired token');
    final channel = auth.createWebSocket(token);
    return KeenApiClient<Action, Update>.fromWebSocket(
      channel: channel,
      actionSerializer: _actionSerializer,
      updateDeserializer: _updateDeserializer,
    );
  }
}
