import 'dart:io';

import 'package:keen/server.dart';
import 'package:keen/src/client/api/serializer.dart';
import 'package:keen/src/server/api/api.dart';
import 'package:meta/meta.dart';

import 'users/user.dart';

abstract class KeenAuthApiServer<Action, Update>
    extends KeenApiServer<User, Action, Update> {
  KeenAuthServer auth;
  KeenAuthApiServer({
    @required KeenSerializer<Update> updateSerializer,
    @required KeenDeserializer<Action> actionDeserializer,
  }) : super(
          updateSerializer: updateSerializer,
          actionDeserializer: actionDeserializer,
        );

  @override
  Future<User> getSessionInfo(HttpRequest request) async {
    final token = auth.jwt.fromHeaders(request);
    if (!auth.jwt.verify(token)) {
      throw Exception('Unauthorized');
    }
    return await auth.userStorage.getUser(token.payload.userId);
  }
}
